<!--
 Copyright (C) 2024 bAvenir

 This program and the accompanying materials are made
 available under the terms of the Eclipse Public License 2.0
 which is available at https://www.eclipse.org/legal/epl-2.0/

 SPDX-License-Identifier: EPL-2.0
-->

<ng-container *ngIf="online; else offline">
  <ng-container *ngIf="(user$ | async)?.organisation as org">
    <ng-container *ngIf="node$ | async as node; else noNodeSelected">
      <ng-container *ngIf="node">
        <div
          class="w-full h-fit cursor-pointer text-white text-center flex flex-col items-center group text-sm"
          style="background-color: #333a57"
          (click)="showDialog()"
        >
          <div
            *ngIf="solo; else multi"
            class="flex items-center gap-2 w-full justify-center pt-8 group-hover:bg-secondary-900"
          >
            <i class="fa fa-circle-nodes"></i>
            <div class="truncate">{{ node.name }}</div>
          </div>
          <ng-template #multi>
            <div
              class="flex text-white items-center gap-3 w-full h-12 hover:bg-secondary-900"
              (click)="changeNode($event)"
              pTooltip="Change Data Broker"
              tooltipPosition="right"
              showDelay="1000"
            >
              <div class="shrink-0 size-12 bg-primary-500 flex items-center justify-center">
                <i class="fa fa-chevron-left mt-0.5"></i>
              </div>
              <div class="grow flex items-center gap-2 mt-0.5">
                <i class="fa fa-circle-nodes"></i>
                <div class="truncate w-24 text-start leading-none">{{ node.name }}</div>
              </div>
            </div>
          </ng-template>
          <div
            class="flex flex-col items-center w-full pb-8"
            [ngClass]="{ 'group-hover:bg-secondary-900': solo, 'hover:bg-secondary-900': !solo }"
          >
            <div class="w-8 h-0.5 rounded-md bg-white mt-6 opacity-20"></div>
            <div class="text-xs opacity-60 w-40 mt-6">Connected to organisation</div>
            <div class="flex items-center gap-2 font-semibold text-xs mt-1">
              <i class="fa fa-house-user" style="font-size: 0.8rem"></i>
              <div class="mt-0.5">{{ org.name }}</div>
            </div>
            <div class="mt-6 flex gap-2 items-center text-xs text-primary-500 font-semibold">
              <div>Show more</div>
              <i class="fa fa-chevron-down"></i>
            </div>
          </div>
        </div>
      </ng-container>
    </ng-container>
    <ng-template #noNodeSelected>
      <div
        class="w-full h-fit cursor-pointer text-white text-center flex flex-col items-center group text-sm pb-8 hover:bg-secondary-900 bg-[#333a57]"
        (click)="showDialog()"
      >
        <div class="text-xs opacity-60 w-40 mt-10">Connected to organisation</div>
        <div class="flex items-center gap-2 font-semibold text-xs mt-1 pb-4">
          <i class="fa fa-house-user" style="font-size: 0.8rem"></i>
          <div class="mt-0.5">{{ org.name }}</div>
        </div>
        <div class="mt-6 flex gap-2 items-center text-xs text-primary-500 font-semibold">
          <div>Show more</div>
          <i class="fa fa-chevron-down"></i>
        </div>
      </div>
    </ng-template>
  </ng-container>
</ng-container>
<ng-template #offline>
  <div
    class="w-full h-fit cursor-pointer pb-8 pt-8 text-white text-center flex flex-col items-center text-sm"
    style="background-color: #333a57"
    (click)="showDialog()"
  >
    <i class="fa fa-circle-xmark"></i>
    <div class="mt-1 text-sm">Data Broker is offline</div>
    <ng-container *ngIf="(broker$ | async)?.online; let online">
      <div class="text-xs opacity-60 w-40 mt-2">
        {{
          online
            ? 'This Data Broker is not connected to the organisation'
            : 'This Data Broker is not connected to SPADE platform'
        }}
      </div>
    </ng-container>
    <div class="mt-6 flex gap-2 items-center text-xs text-primary-500 font-semibold">
      <div>Show more</div>
      <i class="fa fa-chevron-down"></i>
    </div>
  </div>
</ng-template>

<app-bottom-sheet [(visible)]="visible">
  <ng-template #header>
    <ng-container *ngLet="node$ | async as node">
      <ng-container *ngLet="broker$ | async as broker">
        <ng-container *ngLet="user$ | async as user">
          <div class="flex items-center w-full h-full gap-1">
            <div class="rounded-sm w-full h-full">
              <div
                class="flex items-center rounded-sm justify-center gap-2 h-full w-56 px-4"
                [ngClass]="{
                'opacity-20': node == undefined,
                'cursor-pointer': node != undefined,
                'active': nodeActive,
                'non-active': !nodeActive,
              }"
                (click)="selectNode($event)"
              >
                <app-type-icon icon="fa fa-circle-nodes" color="#5bc566"></app-type-icon>
                <div class="truncate w-fit" *ngIf="node == undefined">No Data Broker</div>
                <div class="truncate w-fit" *ngIf="online">{{ node?.name }}</div>
                <div class="truncate w-fit" *ngIf="!online">{{ broker?.address }}</div>
              </div>
            </div>
            <div class="rounded-sm w-full h-full">
              <div
                class="flex items-center rounded-sm justify-center gap-2 h-full w-56 px-4"
                [ngClass]="{
                  active: orgActive,
                  'non-active': !orgActive,
                  'opacity-20': !online,
                  'cursor-pointer': online
                }"
                (click)="selectOrg($event)"
              >
                <app-type-icon icon="fa fa-house-user" color="#384570"></app-type-icon>
                <div class="truncate w-fit" *ngIf="user && user.organisation">{{ user.organisation.name }}</div>
              </div>
            </div>
          </div>
        </ng-container>
      </ng-container>
    </ng-container>
  </ng-template>
  <app-node *ngIf="nodeActive"></app-node>
  <app-organisation *ngIf="orgActive"></app-organisation>
</app-bottom-sheet>
